/*
 * JPA entity Metadaten
 *
 */
package de.ivu.elect.business.konfiguration.entity;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.konfiguration.entity.KonfigurationConstants;
import de.ivu.elect.jee.faces.Messages;

@Named(KonfigurationMeta.COMPONENT_NAME)
@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class KonfigurationMeta implements de.ivu.elect.jee.entity.Meta
{

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "konfigurationMeta";

  @Inject
  private transient Messages messages;

  public KonfigurationMeta() {
      super();
  }

  protected String getMessage(String msgKey, Object... params) {
    return messages.getMessageForMessageKey(msgKey, params);
  }

  @Override
  public String getEinzahlMessageKey(){
    return KonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public  String getMehrzahlMessageKey(){
    return KonfigurationConstants.MESSAGE_KEY_ENTITY_MEHRZAHL;
  }


  @Override
  public String getEinzahlMessage() {
    return getMessage(getEinzahlMessageKey());
  }

  @Override
  public String getMehrzahlMessage(){
    return getMessage(getMehrzahlMessageKey());
  }



  public String getSchluesselEinzahlMessageKey(){
    return KonfigurationConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL;
  }

  public String getSchluesselMehrzahlMessageKey(){
    return KonfigurationConstants.MESSAGE_KEY_SCHLUESSEL_MEHRZAHL;
  }


  public String getSchluesselEinzahlMessage(){
    return getMessage(getSchluesselEinzahlMessageKey());
  }

  public String getSchluesselMehrzahlMessage(){
    return getMessage(getSchluesselMehrzahlMessageKey());
  }



  public boolean isSchluesselRequired() {
    return !KonfigurationConstants.SCHLUESSEL_NULLABLE;
  }

  public String getSchluesselDefaultValue() {
    return KonfigurationConstants.SCHLUESSEL_DEFAULT_VALUE;
  }

  public int getSchluesselMaxLength() {
    return KonfigurationConstants.SCHLUESSEL_MAX_LENGTH;
  }

  public String getWertEinzahlMessageKey(){
    return KonfigurationConstants.MESSAGE_KEY_WERT_EINZAHL;
  }

  public String getWertMehrzahlMessageKey(){
    return KonfigurationConstants.MESSAGE_KEY_WERT_MEHRZAHL;
  }


  public String getWertEinzahlMessage(){
    return getMessage(getWertEinzahlMessageKey());
  }

  public String getWertMehrzahlMessage(){
    return getMessage(getWertMehrzahlMessageKey());
  }



  public boolean isWertRequired() {
    return !KonfigurationConstants.WERT_NULLABLE;
  }

  public String getWertDefaultValue() {
    return KonfigurationConstants.WERT_DEFAULT_VALUE;
  }

  public int getWertMaxLength() {
    return KonfigurationConstants.WERT_MAX_LENGTH;
  }


  public String getMandantEinzahlMessageKey(){
    return KonfigurationConstants.MESSAGE_KEY_MANDANT_ID_EINZAHL;
  }

  public String getMandantEinzahlMessage(){
    return getMessage(getMandantEinzahlMessageKey());
  }

  public boolean isMandantRequired() {
    return !KonfigurationConstants.MANDANT_ID_NULLABLE;
  }

}